using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization;

namespace InfiniTec.Threading
{
    /// <summary>
    /// This exception indicates that an async operation was aborted during the execution
    /// </summary>
    [global::System.Serializable]
    public class AsyncOperationAbortedException : AsyncOperationFailedException
    {
        /// <summary>
        /// Creates a new instance of this class.
        /// </summary>
        public AsyncOperationAbortedException() { }
        /// <summary>
        /// Creates a new instance of this class with the specified message
        /// </summary>
        /// <param name="message">The message of the exception</param>
        public AsyncOperationAbortedException(string message) : base(message) { }
        /// <summary>
        /// Creates a new instance of this class with the specified message
        /// </summary>
        /// <param name="message">The message of the exception</param>
        /// <param name="inner">An inner <see cref="Exception"/> "/></param>
        public AsyncOperationAbortedException(string message, Exception inner) : base(message, inner) { }
        /// <summary>
        /// Creates a new instance of this class with the specified message
        /// </summary>
        /// <param name="info">A <see cref="SerializationInfo"/> instance</param>
        /// <param name="context">a <see cref="StreamingContext"/> instance.</param>
        protected AsyncOperationAbortedException(
          SerializationInfo info,
          StreamingContext context)
            : base(info, context) { }
    }
}
