using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization;

namespace InfiniTec.Threading
{
    /// <summary>
    /// This exception indicates that an async operation caused an exception during the execution, which was not handled.
    /// </summary>
    [global::System.Serializable]
    public class AsyncOperationFailedException : Exception
    {
        /// <summary>
        /// Creates a new instance of this class with the specified message
        /// </summary>
        public AsyncOperationFailedException() { }
        /// <summary>
        /// Creates a new instance of this class with the specified message
        /// </summary>
        /// <param name="message">The message of the exception</param>
        public AsyncOperationFailedException(string message) : base(message) { }
        /// <summary>
        /// Creates a new instance of this class with the specified message
        /// </summary>
        /// <param name="message">The message of the exception</param>
        /// <param name="inner">The inner exception</param>
        public AsyncOperationFailedException(string message, Exception inner) : base(message, inner) { }
        ////<summary>Creates a new instance of this class with the specified message</summary>
        /// <param name="info">A <see cref="SerializationInfo"/> instance</param>
        /// <param name="context">a <see cref="StreamingContext"/> instance.</param>
        protected AsyncOperationFailedException(
          SerializationInfo info,
          StreamingContext context)
            : base(info, context) { }
    }
}
