using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;

namespace InfiniTec.Threading
{
    /// <summary>
    /// This attribute is attached to properties of progress updates to mark a property as a nested progress state.
    /// </summary>
    [global::System.AttributeUsage(AttributeTargets.Property, Inherited = false, AllowMultiple = false)]
    public sealed class NestedStateAttribute : Attribute
    {
        /// <summary>
        /// Returns true, if the <see cref="NestedStateAttribute"/> is attached to the specified object.
        /// </summary>
        /// <param name="pi"></param>
        /// <returns></returns>
        public static bool IsDefined(PropertyInfo pi) {
            return IsDefined(pi, typeof(NestedStateAttribute));
        }
    }
    
}
