using System;
using System.Collections.Generic;
using System.Text;

namespace InfiniTec.Threading
{
     /// <summary>
    /// This class contains results from an asynchrnous operation.
    /// </summary>
    /// <typeparam name="ResultType">The result from the operation.</typeparam>
    public class OperationResult<ResultType> : OperationAction
    {
        private ResultType _Result;

        /// <summary>
        /// Returns the result of the operation.
        /// </summary>
        public ResultType Result
        {
            get { return _Result; }
        }

        /// <summary>
        /// Initializes a new instance of this class and with the specified result.
        /// </summary>
        /// <param name="result">The result of the operation.</param>
        public OperationResult(ResultType result)
        {
            _Result = result;
        }
    }

}
