using System;
using System.Collections.Generic;
using System.Text;

namespace InfiniTec.Threading
{
    /// <summary>
    /// Indicates the status of an asynchronous operation.
    /// </summary>
    public enum OperationStatus
    {
        /// <summary>
        /// This is the default value. The operation has not been started yet.
        /// </summary>
        NotStarted,
        /// <summary>
        /// The operation has been started
        /// </summary>
        Started,
        /// <summary>
        /// The operation is currently running.
        /// </summary>
        Running,
        /// <summary>
        /// The operation has been completed.
        /// </summary>
        Completed,
        /// <summary>
        /// An abortion of the operation has been requested.
        /// </summary>
        Aborting,
        /// <summary>
        /// The operation has been aborted.
        /// </summary>
        Aborted,
        /// <summary>
        /// The operation has timed out.
        /// </summary>
        TimedOut,
        /// <summary>
        /// The operation has caused an exception.
        /// </summary>
        Error
    }
}
